// Generated by the protocol buffer compiler.  DO NOT EDIT!
// source: solarmodule/solarmodule.proto

package openfmb.solarmodule;

/**
 * <pre>
 * Solar status profile
 * </pre>
 *
 * Protobuf type {@code solarmodule.SolarStatusProfile}
 */
public final class SolarStatusProfile extends
    com.google.protobuf.GeneratedMessageV3 implements
    // @@protoc_insertion_point(message_implements:solarmodule.SolarStatusProfile)
    SolarStatusProfileOrBuilder {
private static final long serialVersionUID = 0L;
  // Use SolarStatusProfile.newBuilder() to construct.
  private SolarStatusProfile(com.google.protobuf.GeneratedMessageV3.Builder<?> builder) {
    super(builder);
  }
  private SolarStatusProfile() {
  }

  @java.lang.Override
  @SuppressWarnings({"unused"})
  protected java.lang.Object newInstance(
      UnusedPrivateParameter unused) {
    return new SolarStatusProfile();
  }

  public static final com.google.protobuf.Descriptors.Descriptor
      getDescriptor() {
    return openfmb.solarmodule.Solarmodule.internal_static_solarmodule_SolarStatusProfile_descriptor;
  }

  @java.lang.Override
  protected com.google.protobuf.GeneratedMessageV3.FieldAccessorTable
      internalGetFieldAccessorTable() {
    return openfmb.solarmodule.Solarmodule.internal_static_solarmodule_SolarStatusProfile_fieldAccessorTable
        .ensureFieldAccessorsInitialized(
            openfmb.solarmodule.SolarStatusProfile.class, openfmb.solarmodule.SolarStatusProfile.Builder.class);
  }

  public static final int STATUSMESSAGEINFO_FIELD_NUMBER = 1;
  private openfmb.commonmodule.StatusMessageInfo statusMessageInfo_;
  /**
   * <pre>
   * UML inherited base object
   * </pre>
   *
   * <code>.commonmodule.StatusMessageInfo statusMessageInfo = 1 [(.uml.option_parent_message) = true];</code>
   * @return Whether the statusMessageInfo field is set.
   */
  @java.lang.Override
  public boolean hasStatusMessageInfo() {
    return statusMessageInfo_ != null;
  }
  /**
   * <pre>
   * UML inherited base object
   * </pre>
   *
   * <code>.commonmodule.StatusMessageInfo statusMessageInfo = 1 [(.uml.option_parent_message) = true];</code>
   * @return The statusMessageInfo.
   */
  @java.lang.Override
  public openfmb.commonmodule.StatusMessageInfo getStatusMessageInfo() {
    return statusMessageInfo_ == null ? openfmb.commonmodule.StatusMessageInfo.getDefaultInstance() : statusMessageInfo_;
  }
  /**
   * <pre>
   * UML inherited base object
   * </pre>
   *
   * <code>.commonmodule.StatusMessageInfo statusMessageInfo = 1 [(.uml.option_parent_message) = true];</code>
   */
  @java.lang.Override
  public openfmb.commonmodule.StatusMessageInfoOrBuilder getStatusMessageInfoOrBuilder() {
    return statusMessageInfo_ == null ? openfmb.commonmodule.StatusMessageInfo.getDefaultInstance() : statusMessageInfo_;
  }

  public static final int SOLARINVERTER_FIELD_NUMBER = 2;
  private openfmb.solarmodule.SolarInverter solarInverter_;
  /**
   * <pre>
   * MISSING DOCUMENTATION!!!
   * </pre>
   *
   * <code>.solarmodule.SolarInverter solarInverter = 2 [(.uml.option_required_field) = true, (.uml.option_multiplicity_min) = 1];</code>
   * @return Whether the solarInverter field is set.
   */
  @java.lang.Override
  public boolean hasSolarInverter() {
    return solarInverter_ != null;
  }
  /**
   * <pre>
   * MISSING DOCUMENTATION!!!
   * </pre>
   *
   * <code>.solarmodule.SolarInverter solarInverter = 2 [(.uml.option_required_field) = true, (.uml.option_multiplicity_min) = 1];</code>
   * @return The solarInverter.
   */
  @java.lang.Override
  public openfmb.solarmodule.SolarInverter getSolarInverter() {
    return solarInverter_ == null ? openfmb.solarmodule.SolarInverter.getDefaultInstance() : solarInverter_;
  }
  /**
   * <pre>
   * MISSING DOCUMENTATION!!!
   * </pre>
   *
   * <code>.solarmodule.SolarInverter solarInverter = 2 [(.uml.option_required_field) = true, (.uml.option_multiplicity_min) = 1];</code>
   */
  @java.lang.Override
  public openfmb.solarmodule.SolarInverterOrBuilder getSolarInverterOrBuilder() {
    return solarInverter_ == null ? openfmb.solarmodule.SolarInverter.getDefaultInstance() : solarInverter_;
  }

  public static final int SOLARSTATUS_FIELD_NUMBER = 3;
  private openfmb.solarmodule.SolarStatus solarStatus_;
  /**
   * <pre>
   * MISSING DOCUMENTATION!!!
   * </pre>
   *
   * <code>.solarmodule.SolarStatus solarStatus = 3 [(.uml.option_required_field) = true, (.uml.option_multiplicity_min) = 1];</code>
   * @return Whether the solarStatus field is set.
   */
  @java.lang.Override
  public boolean hasSolarStatus() {
    return solarStatus_ != null;
  }
  /**
   * <pre>
   * MISSING DOCUMENTATION!!!
   * </pre>
   *
   * <code>.solarmodule.SolarStatus solarStatus = 3 [(.uml.option_required_field) = true, (.uml.option_multiplicity_min) = 1];</code>
   * @return The solarStatus.
   */
  @java.lang.Override
  public openfmb.solarmodule.SolarStatus getSolarStatus() {
    return solarStatus_ == null ? openfmb.solarmodule.SolarStatus.getDefaultInstance() : solarStatus_;
  }
  /**
   * <pre>
   * MISSING DOCUMENTATION!!!
   * </pre>
   *
   * <code>.solarmodule.SolarStatus solarStatus = 3 [(.uml.option_required_field) = true, (.uml.option_multiplicity_min) = 1];</code>
   */
  @java.lang.Override
  public openfmb.solarmodule.SolarStatusOrBuilder getSolarStatusOrBuilder() {
    return solarStatus_ == null ? openfmb.solarmodule.SolarStatus.getDefaultInstance() : solarStatus_;
  }

  private byte memoizedIsInitialized = -1;
  @java.lang.Override
  public final boolean isInitialized() {
    byte isInitialized = memoizedIsInitialized;
    if (isInitialized == 1) return true;
    if (isInitialized == 0) return false;

    memoizedIsInitialized = 1;
    return true;
  }

  @java.lang.Override
  public void writeTo(com.google.protobuf.CodedOutputStream output)
                      throws java.io.IOException {
    if (statusMessageInfo_ != null) {
      output.writeMessage(1, getStatusMessageInfo());
    }
    if (solarInverter_ != null) {
      output.writeMessage(2, getSolarInverter());
    }
    if (solarStatus_ != null) {
      output.writeMessage(3, getSolarStatus());
    }
    getUnknownFields().writeTo(output);
  }

  @java.lang.Override
  public int getSerializedSize() {
    int size = memoizedSize;
    if (size != -1) return size;

    size = 0;
    if (statusMessageInfo_ != null) {
      size += com.google.protobuf.CodedOutputStream
        .computeMessageSize(1, getStatusMessageInfo());
    }
    if (solarInverter_ != null) {
      size += com.google.protobuf.CodedOutputStream
        .computeMessageSize(2, getSolarInverter());
    }
    if (solarStatus_ != null) {
      size += com.google.protobuf.CodedOutputStream
        .computeMessageSize(3, getSolarStatus());
    }
    size += getUnknownFields().getSerializedSize();
    memoizedSize = size;
    return size;
  }

  @java.lang.Override
  public boolean equals(final java.lang.Object obj) {
    if (obj == this) {
     return true;
    }
    if (!(obj instanceof openfmb.solarmodule.SolarStatusProfile)) {
      return super.equals(obj);
    }
    openfmb.solarmodule.SolarStatusProfile other = (openfmb.solarmodule.SolarStatusProfile) obj;

    if (hasStatusMessageInfo() != other.hasStatusMessageInfo()) return false;
    if (hasStatusMessageInfo()) {
      if (!getStatusMessageInfo()
          .equals(other.getStatusMessageInfo())) return false;
    }
    if (hasSolarInverter() != other.hasSolarInverter()) return false;
    if (hasSolarInverter()) {
      if (!getSolarInverter()
          .equals(other.getSolarInverter())) return false;
    }
    if (hasSolarStatus() != other.hasSolarStatus()) return false;
    if (hasSolarStatus()) {
      if (!getSolarStatus()
          .equals(other.getSolarStatus())) return false;
    }
    if (!getUnknownFields().equals(other.getUnknownFields())) return false;
    return true;
  }

  @java.lang.Override
  public int hashCode() {
    if (memoizedHashCode != 0) {
      return memoizedHashCode;
    }
    int hash = 41;
    hash = (19 * hash) + getDescriptor().hashCode();
    if (hasStatusMessageInfo()) {
      hash = (37 * hash) + STATUSMESSAGEINFO_FIELD_NUMBER;
      hash = (53 * hash) + getStatusMessageInfo().hashCode();
    }
    if (hasSolarInverter()) {
      hash = (37 * hash) + SOLARINVERTER_FIELD_NUMBER;
      hash = (53 * hash) + getSolarInverter().hashCode();
    }
    if (hasSolarStatus()) {
      hash = (37 * hash) + SOLARSTATUS_FIELD_NUMBER;
      hash = (53 * hash) + getSolarStatus().hashCode();
    }
    hash = (29 * hash) + getUnknownFields().hashCode();
    memoizedHashCode = hash;
    return hash;
  }

  public static openfmb.solarmodule.SolarStatusProfile parseFrom(
      java.nio.ByteBuffer data)
      throws com.google.protobuf.InvalidProtocolBufferException {
    return PARSER.parseFrom(data);
  }
  public static openfmb.solarmodule.SolarStatusProfile parseFrom(
      java.nio.ByteBuffer data,
      com.google.protobuf.ExtensionRegistryLite extensionRegistry)
      throws com.google.protobuf.InvalidProtocolBufferException {
    return PARSER.parseFrom(data, extensionRegistry);
  }
  public static openfmb.solarmodule.SolarStatusProfile parseFrom(
      com.google.protobuf.ByteString data)
      throws com.google.protobuf.InvalidProtocolBufferException {
    return PARSER.parseFrom(data);
  }
  public static openfmb.solarmodule.SolarStatusProfile parseFrom(
      com.google.protobuf.ByteString data,
      com.google.protobuf.ExtensionRegistryLite extensionRegistry)
      throws com.google.protobuf.InvalidProtocolBufferException {
    return PARSER.parseFrom(data, extensionRegistry);
  }
  public static openfmb.solarmodule.SolarStatusProfile parseFrom(byte[] data)
      throws com.google.protobuf.InvalidProtocolBufferException {
    return PARSER.parseFrom(data);
  }
  public static openfmb.solarmodule.SolarStatusProfile parseFrom(
      byte[] data,
      com.google.protobuf.ExtensionRegistryLite extensionRegistry)
      throws com.google.protobuf.InvalidProtocolBufferException {
    return PARSER.parseFrom(data, extensionRegistry);
  }
  public static openfmb.solarmodule.SolarStatusProfile parseFrom(java.io.InputStream input)
      throws java.io.IOException {
    return com.google.protobuf.GeneratedMessageV3
        .parseWithIOException(PARSER, input);
  }
  public static openfmb.solarmodule.SolarStatusProfile parseFrom(
      java.io.InputStream input,
      com.google.protobuf.ExtensionRegistryLite extensionRegistry)
      throws java.io.IOException {
    return com.google.protobuf.GeneratedMessageV3
        .parseWithIOException(PARSER, input, extensionRegistry);
  }
  public static openfmb.solarmodule.SolarStatusProfile parseDelimitedFrom(java.io.InputStream input)
      throws java.io.IOException {
    return com.google.protobuf.GeneratedMessageV3
        .parseDelimitedWithIOException(PARSER, input);
  }
  public static openfmb.solarmodule.SolarStatusProfile parseDelimitedFrom(
      java.io.InputStream input,
      com.google.protobuf.ExtensionRegistryLite extensionRegistry)
      throws java.io.IOException {
    return com.google.protobuf.GeneratedMessageV3
        .parseDelimitedWithIOException(PARSER, input, extensionRegistry);
  }
  public static openfmb.solarmodule.SolarStatusProfile parseFrom(
      com.google.protobuf.CodedInputStream input)
      throws java.io.IOException {
    return com.google.protobuf.GeneratedMessageV3
        .parseWithIOException(PARSER, input);
  }
  public static openfmb.solarmodule.SolarStatusProfile parseFrom(
      com.google.protobuf.CodedInputStream input,
      com.google.protobuf.ExtensionRegistryLite extensionRegistry)
      throws java.io.IOException {
    return com.google.protobuf.GeneratedMessageV3
        .parseWithIOException(PARSER, input, extensionRegistry);
  }

  @java.lang.Override
  public Builder newBuilderForType() { return newBuilder(); }
  public static Builder newBuilder() {
    return DEFAULT_INSTANCE.toBuilder();
  }
  public static Builder newBuilder(openfmb.solarmodule.SolarStatusProfile prototype) {
    return DEFAULT_INSTANCE.toBuilder().mergeFrom(prototype);
  }
  @java.lang.Override
  public Builder toBuilder() {
    return this == DEFAULT_INSTANCE
        ? new Builder() : new Builder().mergeFrom(this);
  }

  @java.lang.Override
  protected Builder newBuilderForType(
      com.google.protobuf.GeneratedMessageV3.BuilderParent parent) {
    Builder builder = new Builder(parent);
    return builder;
  }
  /**
   * <pre>
   * Solar status profile
   * </pre>
   *
   * Protobuf type {@code solarmodule.SolarStatusProfile}
   */
  public static final class Builder extends
      com.google.protobuf.GeneratedMessageV3.Builder<Builder> implements
      // @@protoc_insertion_point(builder_implements:solarmodule.SolarStatusProfile)
      openfmb.solarmodule.SolarStatusProfileOrBuilder {
    public static final com.google.protobuf.Descriptors.Descriptor
        getDescriptor() {
      return openfmb.solarmodule.Solarmodule.internal_static_solarmodule_SolarStatusProfile_descriptor;
    }

    @java.lang.Override
    protected com.google.protobuf.GeneratedMessageV3.FieldAccessorTable
        internalGetFieldAccessorTable() {
      return openfmb.solarmodule.Solarmodule.internal_static_solarmodule_SolarStatusProfile_fieldAccessorTable
          .ensureFieldAccessorsInitialized(
              openfmb.solarmodule.SolarStatusProfile.class, openfmb.solarmodule.SolarStatusProfile.Builder.class);
    }

    // Construct using openfmb.solarmodule.SolarStatusProfile.newBuilder()
    private Builder() {

    }

    private Builder(
        com.google.protobuf.GeneratedMessageV3.BuilderParent parent) {
      super(parent);

    }
    @java.lang.Override
    public Builder clear() {
      super.clear();
      bitField0_ = 0;
      statusMessageInfo_ = null;
      if (statusMessageInfoBuilder_ != null) {
        statusMessageInfoBuilder_.dispose();
        statusMessageInfoBuilder_ = null;
      }
      solarInverter_ = null;
      if (solarInverterBuilder_ != null) {
        solarInverterBuilder_.dispose();
        solarInverterBuilder_ = null;
      }
      solarStatus_ = null;
      if (solarStatusBuilder_ != null) {
        solarStatusBuilder_.dispose();
        solarStatusBuilder_ = null;
      }
      return this;
    }

    @java.lang.Override
    public com.google.protobuf.Descriptors.Descriptor
        getDescriptorForType() {
      return openfmb.solarmodule.Solarmodule.internal_static_solarmodule_SolarStatusProfile_descriptor;
    }

    @java.lang.Override
    public openfmb.solarmodule.SolarStatusProfile getDefaultInstanceForType() {
      return openfmb.solarmodule.SolarStatusProfile.getDefaultInstance();
    }

    @java.lang.Override
    public openfmb.solarmodule.SolarStatusProfile build() {
      openfmb.solarmodule.SolarStatusProfile result = buildPartial();
      if (!result.isInitialized()) {
        throw newUninitializedMessageException(result);
      }
      return result;
    }

    @java.lang.Override
    public openfmb.solarmodule.SolarStatusProfile buildPartial() {
      openfmb.solarmodule.SolarStatusProfile result = new openfmb.solarmodule.SolarStatusProfile(this);
      if (bitField0_ != 0) { buildPartial0(result); }
      onBuilt();
      return result;
    }

    private void buildPartial0(openfmb.solarmodule.SolarStatusProfile result) {
      int from_bitField0_ = bitField0_;
      if (((from_bitField0_ & 0x00000001) != 0)) {
        result.statusMessageInfo_ = statusMessageInfoBuilder_ == null
            ? statusMessageInfo_
            : statusMessageInfoBuilder_.build();
      }
      if (((from_bitField0_ & 0x00000002) != 0)) {
        result.solarInverter_ = solarInverterBuilder_ == null
            ? solarInverter_
            : solarInverterBuilder_.build();
      }
      if (((from_bitField0_ & 0x00000004) != 0)) {
        result.solarStatus_ = solarStatusBuilder_ == null
            ? solarStatus_
            : solarStatusBuilder_.build();
      }
    }

    @java.lang.Override
    public Builder mergeFrom(com.google.protobuf.Message other) {
      if (other instanceof openfmb.solarmodule.SolarStatusProfile) {
        return mergeFrom((openfmb.solarmodule.SolarStatusProfile)other);
      } else {
        super.mergeFrom(other);
        return this;
      }
    }

    public Builder mergeFrom(openfmb.solarmodule.SolarStatusProfile other) {
      if (other == openfmb.solarmodule.SolarStatusProfile.getDefaultInstance()) return this;
      if (other.hasStatusMessageInfo()) {
        mergeStatusMessageInfo(other.getStatusMessageInfo());
      }
      if (other.hasSolarInverter()) {
        mergeSolarInverter(other.getSolarInverter());
      }
      if (other.hasSolarStatus()) {
        mergeSolarStatus(other.getSolarStatus());
      }
      this.mergeUnknownFields(other.getUnknownFields());
      onChanged();
      return this;
    }

    @java.lang.Override
    public final boolean isInitialized() {
      return true;
    }

    @java.lang.Override
    public Builder mergeFrom(
        com.google.protobuf.CodedInputStream input,
        com.google.protobuf.ExtensionRegistryLite extensionRegistry)
        throws java.io.IOException {
      if (extensionRegistry == null) {
        throw new java.lang.NullPointerException();
      }
      try {
        boolean done = false;
        while (!done) {
          int tag = input.readTag();
          switch (tag) {
            case 0:
              done = true;
              break;
            case 10: {
              input.readMessage(
                  getStatusMessageInfoFieldBuilder().getBuilder(),
                  extensionRegistry);
              bitField0_ |= 0x00000001;
              break;
            } // case 10
            case 18: {
              input.readMessage(
                  getSolarInverterFieldBuilder().getBuilder(),
                  extensionRegistry);
              bitField0_ |= 0x00000002;
              break;
            } // case 18
            case 26: {
              input.readMessage(
                  getSolarStatusFieldBuilder().getBuilder(),
                  extensionRegistry);
              bitField0_ |= 0x00000004;
              break;
            } // case 26
            default: {
              if (!super.parseUnknownField(input, extensionRegistry, tag)) {
                done = true; // was an endgroup tag
              }
              break;
            } // default:
          } // switch (tag)
        } // while (!done)
      } catch (com.google.protobuf.InvalidProtocolBufferException e) {
        throw e.unwrapIOException();
      } finally {
        onChanged();
      } // finally
      return this;
    }
    private int bitField0_;

    private openfmb.commonmodule.StatusMessageInfo statusMessageInfo_;
    private com.google.protobuf.SingleFieldBuilderV3<
        openfmb.commonmodule.StatusMessageInfo, openfmb.commonmodule.StatusMessageInfo.Builder, openfmb.commonmodule.StatusMessageInfoOrBuilder> statusMessageInfoBuilder_;
    /**
     * <pre>
     * UML inherited base object
     * </pre>
     *
     * <code>.commonmodule.StatusMessageInfo statusMessageInfo = 1 [(.uml.option_parent_message) = true];</code>
     * @return Whether the statusMessageInfo field is set.
     */
    public boolean hasStatusMessageInfo() {
      return ((bitField0_ & 0x00000001) != 0);
    }
    /**
     * <pre>
     * UML inherited base object
     * </pre>
     *
     * <code>.commonmodule.StatusMessageInfo statusMessageInfo = 1 [(.uml.option_parent_message) = true];</code>
     * @return The statusMessageInfo.
     */
    public openfmb.commonmodule.StatusMessageInfo getStatusMessageInfo() {
      if (statusMessageInfoBuilder_ == null) {
        return statusMessageInfo_ == null ? openfmb.commonmodule.StatusMessageInfo.getDefaultInstance() : statusMessageInfo_;
      } else {
        return statusMessageInfoBuilder_.getMessage();
      }
    }
    /**
     * <pre>
     * UML inherited base object
     * </pre>
     *
     * <code>.commonmodule.StatusMessageInfo statusMessageInfo = 1 [(.uml.option_parent_message) = true];</code>
     */
    public Builder setStatusMessageInfo(openfmb.commonmodule.StatusMessageInfo value) {
      if (statusMessageInfoBuilder_ == null) {
        if (value == null) {
          throw new NullPointerException();
        }
        statusMessageInfo_ = value;
      } else {
        statusMessageInfoBuilder_.setMessage(value);
      }
      bitField0_ |= 0x00000001;
      onChanged();
      return this;
    }
    /**
     * <pre>
     * UML inherited base object
     * </pre>
     *
     * <code>.commonmodule.StatusMessageInfo statusMessageInfo = 1 [(.uml.option_parent_message) = true];</code>
     */
    public Builder setStatusMessageInfo(
        openfmb.commonmodule.StatusMessageInfo.Builder builderForValue) {
      if (statusMessageInfoBuilder_ == null) {
        statusMessageInfo_ = builderForValue.build();
      } else {
        statusMessageInfoBuilder_.setMessage(builderForValue.build());
      }
      bitField0_ |= 0x00000001;
      onChanged();
      return this;
    }
    /**
     * <pre>
     * UML inherited base object
     * </pre>
     *
     * <code>.commonmodule.StatusMessageInfo statusMessageInfo = 1 [(.uml.option_parent_message) = true];</code>
     */
    public Builder mergeStatusMessageInfo(openfmb.commonmodule.StatusMessageInfo value) {
      if (statusMessageInfoBuilder_ == null) {
        if (((bitField0_ & 0x00000001) != 0) &&
          statusMessageInfo_ != null &&
          statusMessageInfo_ != openfmb.commonmodule.StatusMessageInfo.getDefaultInstance()) {
          getStatusMessageInfoBuilder().mergeFrom(value);
        } else {
          statusMessageInfo_ = value;
        }
      } else {
        statusMessageInfoBuilder_.mergeFrom(value);
      }
      bitField0_ |= 0x00000001;
      onChanged();
      return this;
    }
    /**
     * <pre>
     * UML inherited base object
     * </pre>
     *
     * <code>.commonmodule.StatusMessageInfo statusMessageInfo = 1 [(.uml.option_parent_message) = true];</code>
     */
    public Builder clearStatusMessageInfo() {
      bitField0_ = (bitField0_ & ~0x00000001);
      statusMessageInfo_ = null;
      if (statusMessageInfoBuilder_ != null) {
        statusMessageInfoBuilder_.dispose();
        statusMessageInfoBuilder_ = null;
      }
      onChanged();
      return this;
    }
    /**
     * <pre>
     * UML inherited base object
     * </pre>
     *
     * <code>.commonmodule.StatusMessageInfo statusMessageInfo = 1 [(.uml.option_parent_message) = true];</code>
     */
    public openfmb.commonmodule.StatusMessageInfo.Builder getStatusMessageInfoBuilder() {
      bitField0_ |= 0x00000001;
      onChanged();
      return getStatusMessageInfoFieldBuilder().getBuilder();
    }
    /**
     * <pre>
     * UML inherited base object
     * </pre>
     *
     * <code>.commonmodule.StatusMessageInfo statusMessageInfo = 1 [(.uml.option_parent_message) = true];</code>
     */
    public openfmb.commonmodule.StatusMessageInfoOrBuilder getStatusMessageInfoOrBuilder() {
      if (statusMessageInfoBuilder_ != null) {
        return statusMessageInfoBuilder_.getMessageOrBuilder();
      } else {
        return statusMessageInfo_ == null ?
            openfmb.commonmodule.StatusMessageInfo.getDefaultInstance() : statusMessageInfo_;
      }
    }
    /**
     * <pre>
     * UML inherited base object
     * </pre>
     *
     * <code>.commonmodule.StatusMessageInfo statusMessageInfo = 1 [(.uml.option_parent_message) = true];</code>
     */
    private com.google.protobuf.SingleFieldBuilderV3<
        openfmb.commonmodule.StatusMessageInfo, openfmb.commonmodule.StatusMessageInfo.Builder, openfmb.commonmodule.StatusMessageInfoOrBuilder> 
        getStatusMessageInfoFieldBuilder() {
      if (statusMessageInfoBuilder_ == null) {
        statusMessageInfoBuilder_ = new com.google.protobuf.SingleFieldBuilderV3<
            openfmb.commonmodule.StatusMessageInfo, openfmb.commonmodule.StatusMessageInfo.Builder, openfmb.commonmodule.StatusMessageInfoOrBuilder>(
                getStatusMessageInfo(),
                getParentForChildren(),
                isClean());
        statusMessageInfo_ = null;
      }
      return statusMessageInfoBuilder_;
    }

    private openfmb.solarmodule.SolarInverter solarInverter_;
    private com.google.protobuf.SingleFieldBuilderV3<
        openfmb.solarmodule.SolarInverter, openfmb.solarmodule.SolarInverter.Builder, openfmb.solarmodule.SolarInverterOrBuilder> solarInverterBuilder_;
    /**
     * <pre>
     * MISSING DOCUMENTATION!!!
     * </pre>
     *
     * <code>.solarmodule.SolarInverter solarInverter = 2 [(.uml.option_required_field) = true, (.uml.option_multiplicity_min) = 1];</code>
     * @return Whether the solarInverter field is set.
     */
    public boolean hasSolarInverter() {
      return ((bitField0_ & 0x00000002) != 0);
    }
    /**
     * <pre>
     * MISSING DOCUMENTATION!!!
     * </pre>
     *
     * <code>.solarmodule.SolarInverter solarInverter = 2 [(.uml.option_required_field) = true, (.uml.option_multiplicity_min) = 1];</code>
     * @return The solarInverter.
     */
    public openfmb.solarmodule.SolarInverter getSolarInverter() {
      if (solarInverterBuilder_ == null) {
        return solarInverter_ == null ? openfmb.solarmodule.SolarInverter.getDefaultInstance() : solarInverter_;
      } else {
        return solarInverterBuilder_.getMessage();
      }
    }
    /**
     * <pre>
     * MISSING DOCUMENTATION!!!
     * </pre>
     *
     * <code>.solarmodule.SolarInverter solarInverter = 2 [(.uml.option_required_field) = true, (.uml.option_multiplicity_min) = 1];</code>
     */
    public Builder setSolarInverter(openfmb.solarmodule.SolarInverter value) {
      if (solarInverterBuilder_ == null) {
        if (value == null) {
          throw new NullPointerException();
        }
        solarInverter_ = value;
      } else {
        solarInverterBuilder_.setMessage(value);
      }
      bitField0_ |= 0x00000002;
      onChanged();
      return this;
    }
    /**
     * <pre>
     * MISSING DOCUMENTATION!!!
     * </pre>
     *
     * <code>.solarmodule.SolarInverter solarInverter = 2 [(.uml.option_required_field) = true, (.uml.option_multiplicity_min) = 1];</code>
     */
    public Builder setSolarInverter(
        openfmb.solarmodule.SolarInverter.Builder builderForValue) {
      if (solarInverterBuilder_ == null) {
        solarInverter_ = builderForValue.build();
      } else {
        solarInverterBuilder_.setMessage(builderForValue.build());
      }
      bitField0_ |= 0x00000002;
      onChanged();
      return this;
    }
    /**
     * <pre>
     * MISSING DOCUMENTATION!!!
     * </pre>
     *
     * <code>.solarmodule.SolarInverter solarInverter = 2 [(.uml.option_required_field) = true, (.uml.option_multiplicity_min) = 1];</code>
     */
    public Builder mergeSolarInverter(openfmb.solarmodule.SolarInverter value) {
      if (solarInverterBuilder_ == null) {
        if (((bitField0_ & 0x00000002) != 0) &&
          solarInverter_ != null &&
          solarInverter_ != openfmb.solarmodule.SolarInverter.getDefaultInstance()) {
          getSolarInverterBuilder().mergeFrom(value);
        } else {
          solarInverter_ = value;
        }
      } else {
        solarInverterBuilder_.mergeFrom(value);
      }
      bitField0_ |= 0x00000002;
      onChanged();
      return this;
    }
    /**
     * <pre>
     * MISSING DOCUMENTATION!!!
     * </pre>
     *
     * <code>.solarmodule.SolarInverter solarInverter = 2 [(.uml.option_required_field) = true, (.uml.option_multiplicity_min) = 1];</code>
     */
    public Builder clearSolarInverter() {
      bitField0_ = (bitField0_ & ~0x00000002);
      solarInverter_ = null;
      if (solarInverterBuilder_ != null) {
        solarInverterBuilder_.dispose();
        solarInverterBuilder_ = null;
      }
      onChanged();
      return this;
    }
    /**
     * <pre>
     * MISSING DOCUMENTATION!!!
     * </pre>
     *
     * <code>.solarmodule.SolarInverter solarInverter = 2 [(.uml.option_required_field) = true, (.uml.option_multiplicity_min) = 1];</code>
     */
    public openfmb.solarmodule.SolarInverter.Builder getSolarInverterBuilder() {
      bitField0_ |= 0x00000002;
      onChanged();
      return getSolarInverterFieldBuilder().getBuilder();
    }
    /**
     * <pre>
     * MISSING DOCUMENTATION!!!
     * </pre>
     *
     * <code>.solarmodule.SolarInverter solarInverter = 2 [(.uml.option_required_field) = true, (.uml.option_multiplicity_min) = 1];</code>
     */
    public openfmb.solarmodule.SolarInverterOrBuilder getSolarInverterOrBuilder() {
      if (solarInverterBuilder_ != null) {
        return solarInverterBuilder_.getMessageOrBuilder();
      } else {
        return solarInverter_ == null ?
            openfmb.solarmodule.SolarInverter.getDefaultInstance() : solarInverter_;
      }
    }
    /**
     * <pre>
     * MISSING DOCUMENTATION!!!
     * </pre>
     *
     * <code>.solarmodule.SolarInverter solarInverter = 2 [(.uml.option_required_field) = true, (.uml.option_multiplicity_min) = 1];</code>
     */
    private com.google.protobuf.SingleFieldBuilderV3<
        openfmb.solarmodule.SolarInverter, openfmb.solarmodule.SolarInverter.Builder, openfmb.solarmodule.SolarInverterOrBuilder> 
        getSolarInverterFieldBuilder() {
      if (solarInverterBuilder_ == null) {
        solarInverterBuilder_ = new com.google.protobuf.SingleFieldBuilderV3<
            openfmb.solarmodule.SolarInverter, openfmb.solarmodule.SolarInverter.Builder, openfmb.solarmodule.SolarInverterOrBuilder>(
                getSolarInverter(),
                getParentForChildren(),
                isClean());
        solarInverter_ = null;
      }
      return solarInverterBuilder_;
    }

    private openfmb.solarmodule.SolarStatus solarStatus_;
    private com.google.protobuf.SingleFieldBuilderV3<
        openfmb.solarmodule.SolarStatus, openfmb.solarmodule.SolarStatus.Builder, openfmb.solarmodule.SolarStatusOrBuilder> solarStatusBuilder_;
    /**
     * <pre>
     * MISSING DOCUMENTATION!!!
     * </pre>
     *
     * <code>.solarmodule.SolarStatus solarStatus = 3 [(.uml.option_required_field) = true, (.uml.option_multiplicity_min) = 1];</code>
     * @return Whether the solarStatus field is set.
     */
    public boolean hasSolarStatus() {
      return ((bitField0_ & 0x00000004) != 0);
    }
    /**
     * <pre>
     * MISSING DOCUMENTATION!!!
     * </pre>
     *
     * <code>.solarmodule.SolarStatus solarStatus = 3 [(.uml.option_required_field) = true, (.uml.option_multiplicity_min) = 1];</code>
     * @return The solarStatus.
     */
    public openfmb.solarmodule.SolarStatus getSolarStatus() {
      if (solarStatusBuilder_ == null) {
        return solarStatus_ == null ? openfmb.solarmodule.SolarStatus.getDefaultInstance() : solarStatus_;
      } else {
        return solarStatusBuilder_.getMessage();
      }
    }
    /**
     * <pre>
     * MISSING DOCUMENTATION!!!
     * </pre>
     *
     * <code>.solarmodule.SolarStatus solarStatus = 3 [(.uml.option_required_field) = true, (.uml.option_multiplicity_min) = 1];</code>
     */
    public Builder setSolarStatus(openfmb.solarmodule.SolarStatus value) {
      if (solarStatusBuilder_ == null) {
        if (value == null) {
          throw new NullPointerException();
        }
        solarStatus_ = value;
      } else {
        solarStatusBuilder_.setMessage(value);
      }
      bitField0_ |= 0x00000004;
      onChanged();
      return this;
    }
    /**
     * <pre>
     * MISSING DOCUMENTATION!!!
     * </pre>
     *
     * <code>.solarmodule.SolarStatus solarStatus = 3 [(.uml.option_required_field) = true, (.uml.option_multiplicity_min) = 1];</code>
     */
    public Builder setSolarStatus(
        openfmb.solarmodule.SolarStatus.Builder builderForValue) {
      if (solarStatusBuilder_ == null) {
        solarStatus_ = builderForValue.build();
      } else {
        solarStatusBuilder_.setMessage(builderForValue.build());
      }
      bitField0_ |= 0x00000004;
      onChanged();
      return this;
    }
    /**
     * <pre>
     * MISSING DOCUMENTATION!!!
     * </pre>
     *
     * <code>.solarmodule.SolarStatus solarStatus = 3 [(.uml.option_required_field) = true, (.uml.option_multiplicity_min) = 1];</code>
     */
    public Builder mergeSolarStatus(openfmb.solarmodule.SolarStatus value) {
      if (solarStatusBuilder_ == null) {
        if (((bitField0_ & 0x00000004) != 0) &&
          solarStatus_ != null &&
          solarStatus_ != openfmb.solarmodule.SolarStatus.getDefaultInstance()) {
          getSolarStatusBuilder().mergeFrom(value);
        } else {
          solarStatus_ = value;
        }
      } else {
        solarStatusBuilder_.mergeFrom(value);
      }
      bitField0_ |= 0x00000004;
      onChanged();
      return this;
    }
    /**
     * <pre>
     * MISSING DOCUMENTATION!!!
     * </pre>
     *
     * <code>.solarmodule.SolarStatus solarStatus = 3 [(.uml.option_required_field) = true, (.uml.option_multiplicity_min) = 1];</code>
     */
    public Builder clearSolarStatus() {
      bitField0_ = (bitField0_ & ~0x00000004);
      solarStatus_ = null;
      if (solarStatusBuilder_ != null) {
        solarStatusBuilder_.dispose();
        solarStatusBuilder_ = null;
      }
      onChanged();
      return this;
    }
    /**
     * <pre>
     * MISSING DOCUMENTATION!!!
     * </pre>
     *
     * <code>.solarmodule.SolarStatus solarStatus = 3 [(.uml.option_required_field) = true, (.uml.option_multiplicity_min) = 1];</code>
     */
    public openfmb.solarmodule.SolarStatus.Builder getSolarStatusBuilder() {
      bitField0_ |= 0x00000004;
      onChanged();
      return getSolarStatusFieldBuilder().getBuilder();
    }
    /**
     * <pre>
     * MISSING DOCUMENTATION!!!
     * </pre>
     *
     * <code>.solarmodule.SolarStatus solarStatus = 3 [(.uml.option_required_field) = true, (.uml.option_multiplicity_min) = 1];</code>
     */
    public openfmb.solarmodule.SolarStatusOrBuilder getSolarStatusOrBuilder() {
      if (solarStatusBuilder_ != null) {
        return solarStatusBuilder_.getMessageOrBuilder();
      } else {
        return solarStatus_ == null ?
            openfmb.solarmodule.SolarStatus.getDefaultInstance() : solarStatus_;
      }
    }
    /**
     * <pre>
     * MISSING DOCUMENTATION!!!
     * </pre>
     *
     * <code>.solarmodule.SolarStatus solarStatus = 3 [(.uml.option_required_field) = true, (.uml.option_multiplicity_min) = 1];</code>
     */
    private com.google.protobuf.SingleFieldBuilderV3<
        openfmb.solarmodule.SolarStatus, openfmb.solarmodule.SolarStatus.Builder, openfmb.solarmodule.SolarStatusOrBuilder> 
        getSolarStatusFieldBuilder() {
      if (solarStatusBuilder_ == null) {
        solarStatusBuilder_ = new com.google.protobuf.SingleFieldBuilderV3<
            openfmb.solarmodule.SolarStatus, openfmb.solarmodule.SolarStatus.Builder, openfmb.solarmodule.SolarStatusOrBuilder>(
                getSolarStatus(),
                getParentForChildren(),
                isClean());
        solarStatus_ = null;
      }
      return solarStatusBuilder_;
    }
    @java.lang.Override
    public final Builder setUnknownFields(
        final com.google.protobuf.UnknownFieldSet unknownFields) {
      return super.setUnknownFields(unknownFields);
    }

    @java.lang.Override
    public final Builder mergeUnknownFields(
        final com.google.protobuf.UnknownFieldSet unknownFields) {
      return super.mergeUnknownFields(unknownFields);
    }


    // @@protoc_insertion_point(builder_scope:solarmodule.SolarStatusProfile)
  }

  // @@protoc_insertion_point(class_scope:solarmodule.SolarStatusProfile)
  private static final openfmb.solarmodule.SolarStatusProfile DEFAULT_INSTANCE;
  static {
    DEFAULT_INSTANCE = new openfmb.solarmodule.SolarStatusProfile();
  }

  public static openfmb.solarmodule.SolarStatusProfile getDefaultInstance() {
    return DEFAULT_INSTANCE;
  }

  private static final com.google.protobuf.Parser<SolarStatusProfile>
      PARSER = new com.google.protobuf.AbstractParser<SolarStatusProfile>() {
    @java.lang.Override
    public SolarStatusProfile parsePartialFrom(
        com.google.protobuf.CodedInputStream input,
        com.google.protobuf.ExtensionRegistryLite extensionRegistry)
        throws com.google.protobuf.InvalidProtocolBufferException {
      Builder builder = newBuilder();
      try {
        builder.mergeFrom(input, extensionRegistry);
      } catch (com.google.protobuf.InvalidProtocolBufferException e) {
        throw e.setUnfinishedMessage(builder.buildPartial());
      } catch (com.google.protobuf.UninitializedMessageException e) {
        throw e.asInvalidProtocolBufferException().setUnfinishedMessage(builder.buildPartial());
      } catch (java.io.IOException e) {
        throw new com.google.protobuf.InvalidProtocolBufferException(e)
            .setUnfinishedMessage(builder.buildPartial());
      }
      return builder.buildPartial();
    }
  };

  public static com.google.protobuf.Parser<SolarStatusProfile> parser() {
    return PARSER;
  }

  @java.lang.Override
  public com.google.protobuf.Parser<SolarStatusProfile> getParserForType() {
    return PARSER;
  }

  @java.lang.Override
  public openfmb.solarmodule.SolarStatusProfile getDefaultInstanceForType() {
    return DEFAULT_INSTANCE;
  }

}

